:::::::::::::::::::::::::::::::::::::::::
::	file: DevP.bat
::	======
::	Author: Bohemia Interactive
::	Description: Creating of P: drive with content required for Buldozer for Arma 3
::	Note: 
::		uses batch file from Tom_48_97 (twitter: @tom_48_97) to get correct admin rights for the creation of P: drive
::		Valve encourages the setup programs to be silent that is why echo is off all the time
::	Wiki:
::		Go to https://community.bistudio.com/wiki/P_drive for more information
:::::::::::::::::::::::::::::::::::::::::
@echo off
cls
::--- Init log file
set logFile="%~dp0devP.rpt"
echo. >> %logFile%
echo ===================================================================== >> %logFile%
echo == %~0 >> %logFile%
echo == Params: %* >> %logFile%
echo. >> %logFile%
call:formatDate 
echo Current time: %formatedDate% >> %logFile%
echo ===================================================================== >> %logFile%

::--- Script parameters
set P_DrivePersistent=1
set A3_User=0
set SETTINGS="%~dp0settings.ini"
set startUp="%ProgramData%\Microsoft\Windows\Start Menu\Programs\StartUp\mapdisk.bat"

::--- Get path to Arma dir
if exist %SETTINGS% (
	call:getValue %SETTINGS% "A3_User" "Arma3" A3_User
	call:getValue %SETTINGS% "mapFolders" "Arma3Tools" mapFolders
) 
if %A3_User% EQU 0 (
	:v64_path_a3
	For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') Do (set ArmAPath=%%B) & IF NOT DEFINED ArmAPath (goto v32_path_a3) else (goto then)
	:v32_path_a3
	For /F "Tokens=2* skip=2" %%C In ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') Do (set ArmAPath=%%D) & IF NOT DEFINED ArmAPath (goto uac_PATH_a3) else (goto then)
	:uac_PATH_a3
	for /F "tokens=2* delims=	 " %%I IN ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') DO (SET ArmAPath=%%J) & IF NOT DEFINED ArmAPath (goto std_PATH_a3) else (goto then)
	:std_PATH_a3
	for /F "tokens=2* delims=	 " %%K IN ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') DO (SET ArmAPath=%%L) 
) else (
	call:getValue %SETTINGS% "A3_Path" "General" ArmAPath
)
:then

::--- Get path to Arma 3 installation
echo Arma 3 path is %ArmAPath% >> %logFile% 2>&1
echo Arma 3 Tools path is %~dp0 >> %logFile% 2>&1

::--- Check P_Drive key exists, if not, add it
set ArmAWorkPath=0
For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKEY_CURRENT_USER\SOFTWARE\Bohemia Interactive\P Drive" /v "Path"') Do (set ArmAWorkPath=%%B)
if not exist "%ArmAWorkPath%" (
	set ArmAWorkPath="%~dp0"
	echo ArmAWorkPath Registry entry is missing, now adding it >> %logFile% 2>&1
	REG ADD "HKEY_CURRENT_USER\SOFTWARE\Bohemia Interactive\P Drive" /F /v "Path" /t reg_sz /d "%~dp0" >> %logFile% 2>&1
)

::--- Exec the given script command
if "%1" EQU "-clearInstall" goto:clearInstall
if "%1" EQU "-cleanInstall" goto:clearInstall

::--- DISPLAY DEBUG RESULTS
if "%1"=="-DEBUG" (
	echo DEBUG RESULTS
	echo Arma 3 path user defined? %A3_User%
	echo Arma 3 path is "%ArmAPath%"
	echo ArmAWorkPath path is "%ArmAWorkPath%" - Registry value
	pause
	exit /B
)

::--- Call mapdisk
if exist p: (
	if not exist "p:\AddonBuilder.exe" (subst p: /d)
)
call mapdisk.bat >> %logFile% 2>&1

::--- if P is absent after mapdisk, we cannot proceed
if not exist p: goto:error_3

::--- If Arma path does not exist, we cannot proceed
if not exist "%ArmAPath%" goto:error_1

::--- 
if not exist "P:\A3" 			mkdir P:\A3 >> %logFile% 2>&1
if not exist "P:\A3\Data_F" 	mkdir P:\A3\Data_F >> %logFile% 2>&1
if not exist "P:\Bin" 			mkdir P:\Bin >> %logFile% 2>&1
if not exist "P:\Core"			mkdir P:\Core >> %logFile% 2>&1
if not exist "%temp%\BIStudio"	mkdir %temp%\BIStudio >> %logFile% 2>&1
if not exist "%temp%\BIStudio\Bin"	mkdir %temp%\BIStudio\Bin >> %logFile% 2>&1
if not exist "%temp%\BIStudio\Core" 	mkdir %temp%\BIStudio\Core >> %logFile% 2>&1

::--- Uncompressing required files from Arma 3
Bankrev\bankrev.exe -f %temp%\BIStudio\Bin "%ArmAPath%\Dta\bin.pbo" >> %logFile% 2>&1
Bankrev\bankrev.exe -f %temp%\BIStudio\Core "%ArmAPath%\Dta\core.pbo" >> %logFile% 2>&1

::--- Removed previous content (to be sure the client is up to date) 
del /A:h /Q "p:\PhysX3_x86.dll" >> %logFile% 2>&1
del /A:h /Q "p:\PhysX3Common_x86.dll" >> %logFile% 2>&1
del /A:h /Q "p:\PhysX3Cooking_x86.dll" >> %logFile% 2>&1
del /A:h /Q "p:\PhysX3Gpu_x86.dll" >> %logFile% 2>&1
del "P:\buldozer.exe" >> %logFile% 2>&1
echo 107410 > p:\steam_appid.txt

::--- Copy requirements for Buldozer
copy /D "Samples_F\Data_F\halfa.paa" "P:\A3\Data_F\halfa.paa" /Y >> %logFile% 2>&1
xcopy /Q /D /S /E /Y %temp%\BIStudio\Bin\Bin\*.* "P:\Bin" >> %logFile% 2>&1
xcopy /Q /D /S /E /Y %temp%\BIStudio\Core\Core\*.* "P:\Core" >> %logFile% 2>&1
copy /Y /B /V /L "%ArmAPath%\arma3.exe" "P:\buldozer.exe" >> %logFile% 2>&1
xcopy /Q /-Y "%ArmAPath%\PhysX3_x86.dll" P:\ & attrib +h "P:\PhysX3_x86.dll" >> %logFile% 2>&1
xcopy /Q /-Y "%ArmAPath%\PhysX3Common_x86.dll" P:\ & attrib +h "P:\PhysX3Common_x86.dll"  >> %logFile% 2>&1
xcopy /Q /-Y "%ArmAPath%\PhysX3Cooking_x86.dll" P:\ & attrib +h  "P:\PhysX3Cooking_x86.dll" >> %logFile% 2>&1
xcopy /Q /-Y "%ArmAPath%\PhysX3Gpu_x86.dll" P:\ & attrib +h  "P:\PhysX3Gpu_x86.dll" >> %logFile% 2>&1

::--- Call mapfolder
call mapfolders.bat >> %logFile% 2>&1

::--- Clean & exit
rmdir /Q /S %temp%\BIStudio\ >> %logFile% 2>&1
exit /B

:clearInstall
if exist %startUp% (del %startUp% >> %logFile% 2>&1)
rmdir /Q /S "P:\A3" >> %logFile% 2>&1
rmdir /Q /S "P:\Bin" >> %logFile% 2>&1
rmdir /Q /S "P:\Core" >> %logFile% 2>&1
del "P:\buldozer.exe" >> %logFile% 2>&1
del /Q /S p:\PhysX3_x86.dll >> %logFile% 2>&1
del /Q /S p:\PhysX3Common_x86.dll >> %logFile% 2>&1
del /Q /S p:\PhysX3Cooking_x86.dll >> %logFile% 2>&1
del /Q /S p:\PhysX3Gpu_x86.dll >> %logFile% 2>&1
rmdir /Q /S %temp%\BIStudio\ >> %logFile% 2>&1
subst p: /d >> %logFile% 2>&1
if exist %startUp% (del %startUp%)
if "%1" EQU "cleanInstall" (call devP.bat & exit /B)
exit 0

::---------------------------------------------------------------------------
::	ERRORS
::---------------------------------------------------------------------------
:error_1
echo.  >> %logFile% 2>&1
echo /!\ CRITICAL ERROR 1 /!\ >> %logFile% 2>&1
echo DevP was unable to find your Arma 3 installation. >> %logFile% 2>&1
echo Define your path to Arma 3 in the file %SETTINGS% >> %logFile% 2>&1
echo this script will exit in... >> %logFile% 2>&1
echo. >> %logFile% 2>&1
echo ACTION CANCELLED >> %logFile% 2>&1
echo ERROR 1, look at %logFile%
timeout /T 3 /noBreak 
exit 1

:error_3
echo.  >> %logFile% 2>&1
echo /!\ CRITICAL ERROR 3 /!\ >> %logFile% 2>&1
echo DevP was unable to find your P Drive >> %logFile% 2>&1
echo. >> %logFile% 2>&1
echo ACTION CANCELLED >> %logFile% 2>&1
echo ERROR 3, look at %logFile%
timeout /T 3 /noBreak 
exit 3

::---------------------------------------------------------------------------
::	FUNCTIONS
::---------------------------------------------------------------------------
:getValue
::	Description:
::		returns the given value from the ini
::	Parameter(s):
::		%1 - ini file
::		%2 - search term
::		%3 - group name
::		%4 - variable name to store the value
::	Returns:
::		Any - Value of the key
FOR /F "eol=; eol=[ tokens=1,2* delims==" %%i in ('findstr /b /l /i %~2= %1') DO set %~4=%%~j >> %logFile% 2>&1
goto:eof

:formatDate
::	Description:
::		Set the real date & time
::	Parameter(s):
::	Returns:
set timeIs=%TIME::=-%
set today=%DATE:/=-%
set formatedDate=%today% %timeIs%
goto:eof