:::::::::::::::::::::::::::::::::::::::::
::	file: mapdisk.bat
::	======
::	Author: Tom_48_97 - twitter: @tom_48_97
::	Description: Mapping of P: for users and admins (quick'n dirty)
::	Note: 
::		Valve encourages the setup programs to be silent that is why echo is off all the time
::	Wiki: 
::		Go to https://community.bistudio.com/wiki/P_drive for more information
:::::::::::::::::::::::::::::::::::::::::
:: Small kid, after this line, GET OUT OF MY CODE ;-)
@echo off
cls 
::--- Parameters
set ArmAWorkPath=0
set P_DriveUser=0
set SETTINGS="%~dp0settings.ini"
set logFile="%~dp0devP.rpt"
if exist %SETTINGS% (
	call:getValue %SETTINGS% "P_DriveUser" "P_Drive" P_DriveUser
) else (
	set P_DriveUser = 0
)

echo %P_DriveUser%
::--- Get P_Drive path
if %P_DriveUser% EQU 0 For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKEY_CURRENT_USER\SOFTWARE\Bohemia Interactive\P Drive" /v "Path"') Do (set ArmAWorkPath=%%B)
if %P_DriveUser% EQU 1 call:getValue %SETTINGS% "P_DrivePath" "P_Drive" ArmAWorkPath


::--- DISPLAY DEBUG RESULTS
if "%1"=="-DEBUG" (
	echo DEBUG RESULTS
	echo ArmAWorkPath path user defined? %P_DriveUser%
	echo ArmAWorkPath path is "%ArmAWorkPath%"
	pause
	exit /b
)

::--- If previous methods failed to determined path, use the current folder of mapdisk
if not exist "%ArmAWorkPath%" (set ArmAWorkPath="%~dp0")
if not exist "%ArmAWorkPath%" goto:error_2

::--- Mapping user side
subst p: "%ArmAWorkPath%"

::--- If UAC is ON, bypass it
NET FILE 1>NUL 2>NUL
if '%errorlevel%' == '0' (goto gotEscalation) else (goto getEscalation)

::--- Bypass UAC
:getEscalation
if '%1'=='ELEV' (shift & goto gotEscalation)  
setlocal DisableDelayedExpansion
set "localpath=%~0"
setlocal EnableDelayedExpansion
echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\BIS_getEscalation.vbs" 
echo UAC.ShellExecute "!localpath!", "ELEV", "", "runas", 1 >> "%temp%\BIS_getEscalation.vbs" 
"%temp%\BIS_getEscalation.vbs" 
exit /B 

::--- UAC not present or bypassed
:gotEscalation
::---  Mapping admin side
setlocal & pushd .
subst p: "%ArmAWorkPath%"

::--- clean & exit
del %temp%\BIS_getEscalation.vbs
exit /B

::---------------------------------------------------------------------------
::	ERRORS
::---------------------------------------------------------------------------
:error_2
echo. 
echo /!\ CRITICAL ERROR 2 /!\ >> %logFile% 2>&1
echo MapDisk was unable to find your ArmAWorkPath  >> %logFile% 2>&1
echo Define your path to Arma 3 Tools (P_DrivePath and define P_DriveUser=1) in the file %SETTINGS%  >> %logFile% 2>&1
echo ERROR 2, look at %logFile%
timeout /T 3 /noBreak 
if not exist "%temp%\BIS_getEscalation.vbs" (exit 2) else (del "%temp%\BIS_getEscalation.vbs" & exit 1)
exit 2

::---------------------------------------------------------------------------
::	FUNCTIONS
::---------------------------------------------------------------------------
:getValue
::	Description:
::		returns the given value from the ini
::	Parameter(s):
::		%1 - ini file
::		%2 - search term
::		%3 - group name
::		%4 - variable name to store the value
::	Returns:
::		Any - Value of the key
FOR /F "eol=; eol=[ tokens=1,2* delims==" %%i in ('findstr /b /l /i %~2= %1') DO set %~4=%%~j
goto:eof