:::::::::::::::::::::::::::::::::::::::::
::	file: mapfolders.bat
::	======
::	Author: Tom_48_97 - twitter: @tom_48_97
::	Description: Creating of virtual directories between Arma 3 installation folder and ArmA 3 Tools folder.
::	Note: 
::		Valve encourages the setup programs to be silent that is why echo is off all the time
::	Usage:
::		"mapfolders.bat": Default behaviour
::		"mapFolder.bat -DEBUG": Only display the paths and values used, no action will be made.
::	Wiki:
::		Go to https://community.bistudio.com/wiki/mapfolders for more information
:::::::::::::::::::::::::::::::::::::::::
:: Small kid, after this line, GET OUT OF MY CODE ;-)
@echo off
cls 
if "%1"=="-DEBUG" goto getPath
NET FILE 1>NUL 2>NUL
if '%errorlevel%' == '0' (goto gotEscalation) else (goto getEscalation) 

::--- Bypass UAC
:getEscalation
if '%1'=='ELEV' (shift & goto gotEscalation)  
setlocal DisableDelayedExpansion
set "localpath=%~0"
setlocal EnableDelayedExpansion
echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\BIS_mapfolders.vbs" 
echo UAC.ShellExecute "!localpath!", "ELEV", "", "runas", 1 >> "%temp%\BIS_mapfolders.vbs" 
"%temp%\BIS_mapfolders.vbs" 
exit /B 

::--- UAC not present or bypassed
:gotEscalation
setlocal & pushd .
:getPath
set SETTINGS="%~dp0settings.ini"

::--- Get user defined parameters
if exist %SETTINGS% (
	call:getValue %SETTINGS% "A3_User" "Arma3" A3_User
	call:getValue %SETTINGS% "P_DriveUser" "P_Drive" P_DriveUser
	call:getValue %SETTINGS% "texViewPath" "thirdparty" texViewPath
	call:getValue %SETTINGS% "fsmEditor" "thirdparty" fsmEditor
	call:getValue %SETTINGS% "poseidonPath" "thirdparty" poseidonPath
	call:getValue %SETTINGS% "mapFolders" "Arma3Tools" mapFolders
) else (
	exit 0
)


if %mapFolders%==0 (
	if "%1"=="-DEBUG" (
		rem do nothing
	) else (
		exit 0
	)
)

::--- Get path to ArmaWork (default is Arma 3 Tools)
if %P_DriveUser% EQU 1 (
	call:getValue %SETTINGS% "P_DrivePath" "P_Drive" ArmAWorkPath
) else (
	For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKEY_CURRENT_USER\SOFTWARE\Bohemia Interactive\P Drive" /v "Path"') Do (set ArmAWorkPath=%%B)
)

::--- Get path to Arma 3 installation
if %A3_User% EQU 1 (
	call:getValue %SETTINGS% "A3_Path" "General" ArmAPath
	goto then
) else (
	:v64_path_a3
	For /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') Do (set ArmAPath=%%B) & IF NOT DEFINED ArmAPath (goto v32_path_a3) else (goto then)
	:v32_path_a3
	For /F "Tokens=2* skip=2" %%C In ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') Do (set ArmAPath=%%D) & IF NOT DEFINED ArmAPath (goto uac_PATH_a3) else (goto then)
	:uac_PATH_a3
	for /F "tokens=2* delims=	 " %%I IN ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Bohemia Interactive\Arma 3" /v "MAIN"') DO (SET ArmAPath=%%J) & IF NOT DEFINED ArmAPath (goto std_PATH_a3) else (goto then)
	:std_PATH_a3
	for /F "tokens=2* delims=	 " %%K IN ('REG QUERY "HKLM\SOFTWARE\Bohemia Interactive\Arma 3" /v "MAIN"') DO (SET ArmAPath=%%L)  & IF NOT DEFINED ArmAPath (goto steam_v64_path) else (goto then)
	:steam_v64_path
	for /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Wow6432Node\Valve\Steam" /v "InstallPath" 2^>nul') do (set ArmAPath=%%B\steamapps\common\Arma 3)  & IF NOT DEFINED ArmAPath (goto steam_v32_path) else (goto then)
	:steam_v32_path
	for /F "Tokens=2* skip=2" %%A In ('REG QUERY "HKLM\SOFTWARE\Valve\Steam" /v "InstallPath" 2^>nul') do (set ArmAPath=%%B\steamapps\common\Arma 3)
)
:then

::--- DISPLAY DEBUG RESULTS
if "%1"=="-DEBUG" (
	echo DEBUG RESULTS
	echo Arma 3 path user defined? %A3_User%
	echo Arma 3 path is "%ArmAPath%"
	echo ArmAWorkPath path user defined? %P_DriveUser%
	echo ArmAWorkPath path is "%ArmAWorkPath%"
	echo TexView path is "%texViewPath%"
	echo fsmEditor path is "%fsmEditorPath%"
	echo Poseidon path is "%poseidonPath%"
	pause
	exit /B
)

::--- Make links
if exist "%ArmAPath%" (
	if not exist "%ArmAPath%\RenderWorlds" mklink /D "%ArmAPath%\RenderWorlds" "%ArmAWorkPath%\RenderWorlds"
	if not exist "%ArmAWorkPath%\A3_Retail" mklink /D "%ArmAWorkPath%\A3_Retail" "%ArmAPath%"
)
if exist %texViewPath% mklink /D "%ArmAWorkPath%\TexView" %texViewPath%
if exist %fsmEditor% mklink /D "%ArmAWorkPath%\FsmEditor" %fsmEditor%
if exist %poseidonPath% mklink /D "%ArmAWorkPath%\Poseidon" %poseidonPath%

::--- clean & exit
if exist %temp%\BIS_mapfolders.vbs del %temp%\BIS_mapfolders.vbs
exit /B

::---------------------------------------------------------------------------
::	FUNCTIONS
::---------------------------------------------------------------------------
:getValue
::	Description:
::		returns the given value from the ini
::	Parameter(s):
::		%1 - ini file
::		%2 - search term
::		%3 - group name, unused
::		%4 - variable name to store the value
::	Returns:
::		Any - Value of the key
FOR /F "eol=; eol=[ tokens=1,2* delims==" %%i in ('findstr /b /l /i %~2= %1') DO set %~4=%%~j
goto:eof